//----------------------------------------------------------------------------------
// aviutlvOC func_proc NbNv
// Copyright (c) 2009 N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <strsafe.h>
#include <intrin.h>

#include "filter.h"

#ifndef ARRAYSIZE
#define ARRAYSIZE(a) (sizeof((a))/sizeof((a)[0]))
#endif

//---------------------------------------------------------------------
// O[oϐ
//---------------------------------------------------------------------
#define ID_EDIT 2234
HWND g_edit = NULL;
int g_hooked_id = -1;
BOOL (*g_orig_func_proc)(void *, FILTER_PROC_INFO *) = NULL;
TCHAR g_buf[1024];

//---------------------------------------------------------------------
// ֐
//---------------------------------------------------------------------
static void init_cfg_window(HWND hwnd, FILTER *fp);
static void change_filter(FILTER *fp);
static void hook_filter(FILTER *fp);
static void unhook_filter(FILTER *fp);

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
LPSTR track_name[] = { "ID" };
int track_default[] = { 0 };
int track_s[] = { 0 };
int track_e[] = { 0 };

FILTER_DLL filter = {
    FILTER_FLAG_EX_INFORMATION | FILTER_FLAG_WINDOW_SIZE,
    320, 82,
    "NbNvFP",
    ARRAYSIZE(track_name), track_name, track_default, track_s, track_e,
    0, NULL, NULL,
    NULL, func_init, NULL, NULL,
    func_WndProc,
    NULL, NULL, NULL, 0,
    "getclk_p by N099, ver1.1",
  NULL, NULL,
};

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
FILTER_DLL * __stdcall GetFilterTable(void)
{
    return &filter;
}

//---------------------------------------------------------------------
// ɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
    //vOC擾
    SYS_INFO si = { 0, };
    if(!fp->exfunc->get_sys_info(NULL, &si)){
        return FALSE;
    }else{
        track_e[0] = si.filter_n - 1;
        fp->exfunc->filter_window_update(fp);
    }
    
    return TRUE;
}

//---------------------------------------------------------------------
// tB^֐iwtB^tbNj
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
    BOOL ret;
    LARGE_INTEGER s,e;
    
    if(g_orig_func_proc == NULL){
        return FALSE;
    }
    
    QueryPerformanceCounter(&s);
    ret = g_orig_func_proc(fp, fpip);
    QueryPerformanceCounter(&e);
    
    _mm_empty();
    
    //ҏŴݕ\
    if(!fp->exfunc->is_saving(fpip->editp) && g_edit){
        e.QuadPart -= s.QuadPart;
        QueryPerformanceFrequency(&s);
        
        StringCbPrintfA(g_buf, sizeof(g_buf), "%sF%.6E(sec)",
                       fp->name, (double)e.QuadPart/(double)s.QuadPart);
        SendMessage(g_edit, WM_SETTEXT, 0, (LPARAM)g_buf);
    }
    
    return ret;
}

//---------------------------------------------------------------------
// ݒEBhEɃEBhEbZ[WɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_WndProc(HWND h, UINT m, WPARAM w, LPARAM l, void *e, FILTER *fp)
{
    switch(m){
      case WM_FILTER_CHANGE_ACTIVE:
        if(fp->exfunc->is_filter_active(fp)){
            hook_filter(fp);
        }else{
            unhook_filter(fp);
        }
        break;
      case WM_FILTER_CHANGE_PARAM:
        change_filter(fp);
        break;
      case WM_FILTER_INIT:
        init_cfg_window(h, fp);
        return TRUE;
    }
    
    return FALSE;
}

//---------------------------------------------------------------------
// ݒEBhȄ֐
//---------------------------------------------------------------------
void init_cfg_window(HWND hwnd, FILTER *fp)
{
    g_edit = CreateWindow(TEXT("EDIT"), NULL,
                          WS_VISIBLE | WS_CHILD | WS_BORDER | ES_READONLY,
                          4, 37,
                          294, 17,
                          hwnd, (HMENU)ID_EDIT, fp->dll_hinst, NULL);
    
    if(g_edit){
        SendMessage(g_edit, WM_SETFONT,
                    (WPARAM)GetStockObject(DEFAULT_GUI_FONT), FALSE);
        change_filter(fp);
    }
}

//---------------------------------------------------------------------
// ΏۃtB^ύXꂽƂ
//---------------------------------------------------------------------
void change_filter(FILTER *fp)
{
    //tbNĂȂƂȊO
    if(g_hooked_id >= 0 || g_orig_func_proc != NULL){
        return;
    }
    
    if(g_edit){
        FILTER *tgt = (FILTER*)fp->exfunc->get_filterp(fp->track[0]);
        if(tgt){
            StringCbPrintfA(g_buf, sizeof(g_buf), "%sF%s",
                            tgt->name, tgt->func_proc ? "" : "~");
            SendMessageA(g_edit, WM_SETTEXT, 0, (LPARAM)g_buf);
        }
    }
}

//---------------------------------------------------------------------
// ΏۃtB^tbN
//---------------------------------------------------------------------
void hook_filter(FILTER *fp)
{
    FILTER *tgt;
    
    if(g_hooked_id >= 0 || g_orig_func_proc != NULL){
        return;
    }

    tgt = (FILTER*)fp->exfunc->get_filterp(fp->track[0]);
    if(tgt){
        if(tgt->func_proc){
            g_hooked_id = fp->track[0];
            g_orig_func_proc = tgt->func_proc;
            tgt->func_proc = func_proc;
        }
    }
}

//---------------------------------------------------------------------
// ΏۃtB^̃tbN
//---------------------------------------------------------------------
void unhook_filter(FILTER *fp)
{
    FILTER *tgt;
    
    if(g_hooked_id < 0 || g_orig_func_proc == NULL){
        return;
    }

    tgt = (FILTER*)fp->exfunc->get_filterp(g_hooked_id);
    if(tgt){
        if(tgt->func_proc != func_proc){
            MessageBoxA(NULL, "func_proc()Ă܂B\n"
                        "ȍ~EłȂ\܂B",
                        fp->name, MB_ICONWARNING|MB_SYSTEMMODAL);
        }
        tgt->func_proc = g_orig_func_proc;
    }
    
    g_hooked_id = -1;
    g_orig_func_proc = NULL;
}

