//----------------------------------------------------------------------------------
// aviutlvOC NbNv
// Copyright (c) 2005-2007  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <shlwapi.h>
#include <strsafe.h>

#include "filter.h"

typedef LONGLONG (__stdcall * FnGetClock)(void);
BOOL func_proc_master(FILTER *fp, FILTER_PROC_INFO *fpip);
BOOL func_proc_slave(FILTER *fp, FILTER_PROC_INFO *fpip);

#ifndef ARRAYSIZE
#define ARRAYSIZE(a) (sizeof((a))/sizeof((a)[0]))
#endif

//---------------------------------------------------------------------
// ftHg̃t@CƃtB^
//---------------------------------------------------------------------
#define DEFAULT_FILE_NAME _T("getclock.auf")
TCHAR filter_name[128] = _T("NbNv");

//---------------------------------------------------------------------
// O[oϐ
//---------------------------------------------------------------------
LARGE_INTEGER g_start;
double g_qpf = 1.0;
volatile LONG g_token = 0;

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
#define CHECK_N 0
LPSTR check_name[] = { "bPʂŕ\" };
int check_default[] = { 0 };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION, 0,0,
  filter_name, //tB^̖O
  0, NULL, NULL, NULL, NULL,
  CHECK_N, check_name, check_default,
  func_proc_master,   //tB^֐ւ̃|C^ (NULLȂĂ΂܂)
  func_init,   //JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,        //IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,        //ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,        //ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^
  NULL,NULL,   //VXeŎg܂̂ŎgpȂł
  NULL,        //  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  0,           //  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  "getclock by N099, ver1.1",
  NULL, NULL,
};

//---------------------------------------------------------------------
//     DLL̃Gg|Cg
//---------------------------------------------------------------------
BOOL APIENTRY DllMain(HANDLE hModule, DWORD reason, LPVOID Reserved)
{
  if(reason == DLL_PROCESS_ATTACH){
    //t@CύXĂꍇAtB^ύX
    TCHAR name[MAX_PATH];
    if(GetModuleFileName(hModule, name, ARRAYSIZE(name) - 1)){
      PathStripPath(name);

      //OύXĂ΃X[uƂē삷
      if(_tcscmp(name, DEFAULT_FILE_NAME)){
        filter.func_proc = func_proc_slave;
        PathRemoveExtension(name);
        StringCchCat(filter_name, ARRAYSIZE(filter_name), &name[_tcslen(name)-1]);
      }
    }
  }

  return TRUE;
}

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
FILTER_DLL * __stdcall GetFilterTable(void)
{
  return &filter;
}

//---------------------------------------------------------------------
// ɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
  //1b̃NbNJEg擾
  LARGE_INTEGER ticFreq = {0,0};
  QueryPerformanceFrequency(&ticFreq);
  if(ticFreq.QuadPart>0){
    g_qpf = (double)ticFreq.QuadPart;
  }
  
  return TRUE;
}

//---------------------------------------------------------------------
// oߎԂ擾
//---------------------------------------------------------------------
LONGLONG __stdcall GetClockDiff(void)
{
  LARGE_INTEGER ed;
  QueryPerformanceCounter(&ed);
  InterlockedIncrement(&g_token);
  return ed.QuadPart - g_start.QuadPart;
}

//---------------------------------------------------------------------
// tB^֐ }X^[p
//---------------------------------------------------------------------
BOOL func_proc_master(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  //ԎtB^΍̂߁AxX[uĂяoꂽƂXV
  if(g_token != (LONG)&g_token){
    QueryPerformanceCounter(&g_start);
    //AhX}WbNio[ƂăZbg
    InterlockedExchange(&g_token, (LONG)&g_token);
  }
  
  return TRUE;
}

//---------------------------------------------------------------------
// tB^֐ X[up
//---------------------------------------------------------------------
BOOL func_proc_slave(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  LONGLONG clk;
  static FnGetClock getclk = NULL;

  //}X^[̃nhvp֐̃Gg|Cg擾
  if(getclk == NULL){
    HANDLE module = GetModuleHandle(DEFAULT_FILE_NAME);
    if(module == NULL){
      return FALSE;
    }else{
      getclk = (FnGetClock)GetProcAddress(module, "GetClockDiff");
    }

    //擾s
    if(getclk == NULL){
      return FALSE;
    }
  }

  //Ԍo߁ij擾
  clk = getclk();
  __asm emms

  //ҏŴݕ\
  if(!fp->exfunc->is_saving(fpip->editp)){
    TCHAR buf[256];
    double d = (double)clk;
#if CHECK_N == 1
    if(fp->check[0]){
      StringCchPrintf(buf, 256, "%s sec:%.5E", filter.name, d/g_qpf);
    }else{
      StringCchPrintf(buf, 256, "%s clk:%.5e", filter.name, d);
    }
#else
    StringCchPrintf(buf, 256, "%s sec:%.5E", filter.name, d/g_qpf);
#endif
    SetWindowText(fp->hwnd, buf);
  }
  
  return TRUE;
}

